Ruby - Bug #8242

Fix rdoc of Range#bsearch
04/09/2013 11:35 PM - yhara (Yutaka HARA)

Status: Closed

Priority: Normal

Assignee: marcandre (Marc-Andre Lafortune)

Target version: 21.0

ruby -v: ruby 2.0.0p0 (2013-02-24 revision Backport: 2.0.0: DONE
39474) [x86_64-darwin12.2.1]

Description

rdoc of Range#bsearch states "the elements must be sorted", but it does not make sense for Range.

Patch:

diff --git a/range.c b/range.c

index 1e4347e..fab0718 100644

--- a/range.c

+++ b/range.c

@@ -512,11 +512,10 @@ is_integer_p(VALUE v)

¢ By using binary search, finds a value in range which meets the given

Qo

o]

condition in O(log n) where n is the size of the array.
condition in O(log n) where n is the size of the range.
You can use this method in two use cases: a find-minimum mode and
a find-any mode. In either case, the elements of the array must be
monotone (or sorted) with respect to the block.
a find-any mode.
In find-minimum mode (this is a good choice for typical use case),
the block must return true or false, and there must be a value x
@@ -524,7 +523,7 @@ is_integer_p(VALUE v)
= the block returns false for any value which is less than x, and
= the block returns true for any value which is greater than or
equal to i.
equal to x.

If x is within the range, this method returns the value x.
Otherwise, it returns nil.

Associated revisions

Revision eb5f361937c6e4307ac34afa93a4ffbd447ef4e0 - 06/02/2013 03:05 AM - zzak (zzak _)

¢ range.c: Fix rdoc on Range#bsearch [Bug #8242] [ruby-core:54143]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@41026 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision eb5f3619 - 06/02/2013 03:05 AM - zzak (zzak _)
e range.c: Fix rdoc on Ranget#bsearch [Bug #8242] [ruby-core:54143]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@41026 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 6f617028a45a00d89f9efa85fe8705eccc297355 - 06/02/2013 01:39 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 41026: [Backport #8242]
* range.c: Fix rdoc on Range#bsearch [Bug #8242] [ruby-core:54143]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_0_0@41033 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 6617028 - 06/02/2013 01:39 PM - nagachika (Tomoyuki Chikanaga)
merge revision(s) 41026: [Backport #8242]

* range.c: Fix rdoc on Range#bsearch [Bug #8242] [ruby-core:54143]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_0_0@41033 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 04/10/2013 01:21 AM - marcandre (Marc-Andre Lafortune)

| understood "sorted" as a synonym of "monotone". The important part is "with respect to the block".
A range can be "sorted with respect to the block", in the same way an array can.
Note that although [-1, 0, 1] is sorted (with respect to <=>), it is not sorted with respect to {|x| x.abs}, for example.

#2 - 04/28/2013 10:40 AM - zzak (zzak _)

@marcandre (Marc-Andre Lafortune) What do you suggest?

#3 - 05/09/2013 11:20 PM - zzak (zzak _)
- Status changed from Open to Assigned

- Assignee changed from mame (Yusuke Endoh) to marcandre (Marc-Andre Lafortune)

#4 - 06/02/2013 12:05 PM - zzak (zzak _)
- Status changed from Assigned to Closed

- % Done changed from 0 to 100

This issue was solved with changeset r41026.
Yutaka, thank you for reporting this issue.

Your contribution to Ruby is greatly appreciated.
May Ruby be with you.

e range.c: Fix rdoc on Range#bsearch [Bug #8242] [ruby-core:54143]

#5 - 06/02/2013 10:38 PM - nagachika (Tomoyuki Chikanaga)
- Backport set to 2.0.0: DONE
